#include <xsb_config.h>
#include <cell_xsb.h> 

#include <jni.h>
#include "edu_stanford_db_xsb_XSBCore.h"
#include "hashtable.h"

#include <stdio.h>
#include <cinterf.h>
#include <string.h> 

#include <basicdefs.h>
#include "javaxsbdefs.h"

char tempstring[MAXBUFSIZE];



void java2prolog(JNIEnv * env, jobject term, prolog_term v, HashTable * hashTable){
 if((*env)->IsInstanceOf(env, term, clsConst)){
	jstring jvalue  =  (*env)->CallObjectMethod(env, term, getFunctorConst);
	char * value = (char *) (*env)->GetStringUTFChars(env, jvalue, 0);
	c2p_string(value,v);
    	(*env)->ReleaseStringUTFChars(env, jvalue, value);
 }

 else if((*env)->IsInstanceOf(env, term, clsInteger)){
	jint value = (*env)->CallIntMethod(env, term, getValueInt);
	c2p_int(value,v);
 }

 else if((*env)->IsInstanceOf(env, term, clsVariable)){
        prolog_term t =0;
	jstring jvalue = (jstring) (*env)->CallObjectMethod(env, term, getVariableVariable);
	const char * variablename = (*env)->GetStringUTFChars(env, jvalue, 0);
	t = (prolog_term) HashTableGet(hashTable, variablename);
	if(t==0){ 
	  char * newstring = strdup(variablename); 		 
	  HashTablePut(hashTable, newstring, (void *) v);
	}		
	else {
	    p2p_unify(v, t);
        }
    	(*env)->ReleaseStringUTFChars(env, jvalue, variablename);
        return;
 }

 else if((*env)->IsInstanceOf(env, term, clsDouble)){
	double value = (double) (*env)->CallDoubleMethod(env, term, getValueDouble);
	c2p_float(value,v);
 }

 else if((*env)->IsInstanceOf(env, term, clsString)){
	jstring jvalue  =  (*env)->CallObjectMethod(env, term, getContentString);
	char * value = (char *) (*env)->GetStringUTFChars(env, jvalue, 0);
	c2p_string(value,v);
    	(*env)->ReleaseStringUTFChars(env, jvalue, value);
 }


else if((*env)->IsInstanceOf(env, term, clsList)){
  prolog_term car;
  prolog_term cdr;
  jobject jhead;
  jobject jrest;
  c2p_list(v);
  car = p2p_car(v);
  cdr = p2p_cdr(v);

  jhead  =  (*env)->CallObjectMethod(env, term, getHeadList);
  jrest  =  (*env)->CallObjectMethod(env, term, getRestList);

  java2prolog(env,  jhead, car, hashTable);
  java2prolog(env,  jrest, cdr, hashTable);
}


else if((*env)->IsInstanceOf(env, term, clsNil)){
	c2p_nil(v);
     }

 else if((*env)->IsInstanceOf(env, term, clsFunctor)){
   int i;
	jstring jfunctor =  (*env)->CallObjectMethod(env, term, getFunctorFunctor);
	char * functor = (char *) (*env)->GetStringUTFChars(env, jfunctor, 0);
	jobjectArray args =(jobjectArray) (*env)->CallObjectMethod(env, term, getArgsFunctor);
	jsize arity = (*env)->GetArrayLength(env, args);
       
        c2p_functor(functor,arity,v);
    	(*env)->ReleaseStringUTFChars(env, jfunctor, functor);
	for(i = 0; i<arity ; i++){
	    jobject jarg = (*env)->GetObjectArrayElement(env, args, (jsize) i );
	    prolog_term t = p2p_arg(v,i+1);
	    java2prolog(env, jarg, t , hashTable);
	}
 }
 else xsb_warn("java2prolog: Unrecognized java term type");
}






