#include <xsb_config.h>
#include <cell_xsb.h> 

#include <jni.h>
#include "edu_stanford_db_xsb_XSBCore.h"
#include "hashtable.h"

#include <stdio.h>
#include <cinterf.h>
#include <string.h> 

#include <basicdefs.h>
#include "javaxsbdefs.h"

jclass clsLiteral = 0;
jmethodID getPredicateSymbolLiteral = 0;
jmethodID getArgsLiteral = 0;
jmethodID isAtomLiteral = 0;

jclass clsProgramClause = 0;
jmethodID getHeadProgramClause = 0;
jmethodID getBodyProgramClause = 0;


jclass clsVariable = 0;
jmethodID getVariableVariable = 0;
jmethodID clsVariableConstructor = 0;


jclass clsInteger = 0;
jmethodID getValueInt = 0;
jmethodID clsIntegerConstructor = 0;


jclass clsDouble = 0;
jmethodID getValueDouble = 0;
jmethodID clsDoubleConstructor = 0;

jclass clsString = 0;
jmethodID getContentString = 0;

jclass clsNil = 0;
jmethodID clsNilConstructor = 0;

jclass clsList = 0;
jmethodID getHeadList = 0;
jmethodID getRestList = 0;
jmethodID setHeadList = 0;
jmethodID setRestList = 0;
jmethodID clsListConstructor = 0;

jclass clsConst = 0;
jmethodID getFunctorConst = 0;
jmethodID clsConstConstructor = 0;

jclass clsFunctor = 0;
jmethodID getArgsFunctor = 0;
jmethodID getFunctorFunctor = 0;
jmethodID clsFunctorConstructor = 0;

void initReferences(JNIEnv * env){        

   jclass tmp =  (*env)->FindClass(env,"edu/stanford/db/lp/Literal");
   clsLiteral = (*env)->NewGlobalRef(env,tmp);
   getPredicateSymbolLiteral = (*env)->GetMethodID(env,clsLiteral, "getPredicateSymbol", "()Ljava/lang/String;");
   getArgsLiteral = (*env)->GetMethodID(env,clsLiteral, "getArgs", "()[Ledu/stanford/db/lp/Term;");
   isAtomLiteral = (*env)->GetMethodID(env,clsLiteral, "isAtom", "()Z");

   clsProgramClause = (*env)->NewGlobalRef(env, (*env)->FindClass(env,"edu/stanford/db/lp/ProgramClause"));
   getHeadProgramClause = (*env)->GetMethodID(env,clsProgramClause, "getHead", "()[Ledu/stanford/db/lp/Literal;");
   getBodyProgramClause = (*env)->GetMethodID(env,clsProgramClause, "getBody", "()[Ledu/stanford/db/lp/Literal;");

   clsInteger =  (*env)->NewGlobalRef(env, (*env)->FindClass(env,"edu/stanford/db/lp/IntegerTerm"));
   getValueInt = (*env)->GetMethodID(env,clsInteger, "getValue", "()I");
 
   clsIntegerConstructor =  (*env)->GetMethodID(env,clsInteger, "<init>", "(I)V");

   clsVariable =  (*env)->NewGlobalRef(env, (*env)->FindClass(env,"edu/stanford/db/lp/VariableTerm"));
   getVariableVariable = (*env)->GetMethodID(env,clsVariable, "getVariable", "()Ljava/lang/String;");

   clsVariableConstructor = (*env)->GetMethodID(env,clsVariable, "<init>", "(Ljava/lang/String;)V");
 
   clsDouble = (*env)->NewGlobalRef(env, (*env)->FindClass(env,"edu/stanford/db/lp/DoubleTerm"));
   getValueDouble = (*env)->GetMethodID(env,clsDouble, "getValue", "()D");
  
  clsDoubleConstructor = (*env)->GetMethodID(env,clsDouble, "<init>", "(D)V");
  
   clsString = (*env)->NewGlobalRef(env, (*env)->FindClass(env,"edu/stanford/db/lp/StringTerm"));
   getContentString = (*env)->GetMethodID(env,clsString, "getContent", "()Ljava/lang/String;");

   clsNil = (*env)->NewGlobalRef(env, (*env)->FindClass(env,"edu/stanford/db/lp/NilTerm"));
  
 clsNilConstructor = (*env)->GetMethodID(env,clsNil, "<init>", "()V");
  
   clsList = (*env)->NewGlobalRef(env, (*env)->FindClass(env,"edu/stanford/db/lp/NonEmptyListTerm"));
   getHeadList = (*env)->GetMethodID(env,clsList, "getHead", "()Ledu/stanford/db/lp/Term;");
   getRestList = (*env)->GetMethodID(env,clsList, "getRest", "()Ledu/stanford/db/lp/Term;");
 
 clsListConstructor = (*env)->GetMethodID(env,clsList,"<init>", "()V");
  
    /* get method id for setHead Method */
    setHeadList = (*env)->GetMethodID(env,clsList, "setHead", "(Ledu/stanford/db/lp/Term;)V");

    /* get method id for setRest Method */
    setRestList = (*env)->GetMethodID(env,clsList, "setRest", "(Ledu/stanford/db/lp/Term;)V");

	

   clsConst = (*env)->NewGlobalRef(env, (*env)->FindClass(env,"edu/stanford/db/lp/ConstTerm"));
   getFunctorConst = (*env)->GetMethodID(env,clsConst, "getFunctor", "()Ljava/lang/String;");
   
  clsConstConstructor = (*env)->GetMethodID(env,clsConst, "<init>", "(Ljava/lang/String;)V");
  
   clsFunctor = (*env)->NewGlobalRef(env, (*env)->FindClass(env,"edu/stanford/db/lp/FunctorTerm"));
   getArgsFunctor =  (*env)->GetMethodID(env,clsFunctor, "getArgs", "()[Ledu/stanford/db/lp/Term;");
   getFunctorFunctor =  (*env)->GetMethodID(env,clsFunctor, "getFunctor", "()Ljava/lang/String;");
   clsFunctorConstructor = (*env)->GetMethodID(env,clsFunctor, "<init>", "(Ljava/lang/String;[Ledu/stanford/db/lp/Term;)V");

}














